module sertopar (serialin, sclk, lrclk, dataL, dataR);

input serialin;
input sclk, lrclk;
output [19:0] dataL;
output [19:0] dataR;

// will be valid on falling edge of LRCK
reg oldlrclk;
reg dataL, dataR;
reg [19:0] sample;
reg [5:0] index;

always @(posedge sclk) oldlrclk <= lrclk;

always @(posedge sclk) begin
	index = index + 1;
	if (lrclk ^ oldlrclk) begin
		index = 0;
		if (oldlrclk) dataR <= sample;
		else dataL <= sample;
	end
	if (index < 20) begin
        	sample <= {sample[18:0],serialin};
        end
end

endmodule
